cls

'mode 2,8  ' 640x400x8 bit
mode 1,8

CONST XOFFSET = 40
CONST YOFFSET = 100
CONST SPRAYSIZE = 2
CONST PLAYWIDTH = 16
CONST PLAYHEIGHT = 12   ' 13 tiles high  (remember array index 0)

MAXLEVEL = 60   ' restore command only works with literals. GRRRRR....

' load tile images onto page 2
page write 2 : cls
load bmp "tiles30x30x12x2.bmp"

sprite read 1,300,0,30,30 ' sprite-ify the open hand
sprite read 2,330,0,30,30 ' sprite-ify the closed hand

' use page 1 as page drawing buffer
page write 1 : cls
sprite show 1,MM.HRES-1,MM.VRES-50,0 ' put both offscreen
sprite show 2,MM.HRES-1,MM.VRES-1,0

nunchuk open 3

dim string currentlevel(PLAYHEIGHT) length PLAYWIDTH+1
dim string fusem(PLAYHEIGHT) length PLAYWIDTH+1  ' array of tiles to explode
dim integer htile, htileleft, htileright

level = 1
tilecount = 1   ' updated by DrawPlayingArea
lastfall = 0    ' keep track of falling tiles

do
  page write 1
  DrawBrickWall   ' fill the screen with bricks
  DrawMetalSign
  page copy 1 to 0, B  ' wait for blanking, then show wall and sign
  d = LoadLevel(level)
  DrawCurrentLevel
  STROKESPEED = 0
  PaintTitle(XOFFSET,YOFFSET,10,rgb(green))

  page write 0
  STROKESPEED = 10
  'pause 1000  ' wait for VGA mode to settle
  PaintTitle(XOFFSET,YOFFSET,10,rgb(green))

  page write 1
  text 500,395+YOFFSET, "Press the space bar to restart level.", "CT" , 1, 1, &hA0A0A0, -1

  do
    ' read user input
    hx = ((nunchuk(JX,3) - 40) * 2.85) + 220 + XOFFSET
    hy = ((220 - nunchuk(JY,3)) * 2.1) +   0 + YOFFSET
    if hx > 660+XOFFSET then hx = 660+XOFFSET
    if hx < 270+XOFFSET then hx = 270+XOFFSET
    if hy > 330+YOFFSET then hy = 330+YOFFSET
    if hy <  30+YOFFSET then hy =  30+YOFFSET

    ' calculate which cell the hand is in
    cx = int((hx - XOFFSET + 15) / 30) - 7
    cy = int((hy - YOFFSET + 15) / 30)

    ' test action button
    if nunchuk(Z,3) then  ' is it pressed?
      TryShiftTiles
    else   'no, it's released
      locky = 0
      sprite show 2,MM.HRES-1,MM.VRES-1,0  ' put closed hand offscreen
      sprite show 1,hx,hy,0   ' show open hand
    endif

    if tilecount = 0 then
      level = level + 1
      sprite show 1,MM.HRES-1,MM.VRES-50,0 ' put them offscreen
      sprite show 2,MM.HRES-1,MM.VRES-1,0
      if not LoadLevel(level) then exit do
      DrawCurrentLevel
    endif

    k$ = inkey$
    if  k$ = " " then  ' restart level if [SPACE] pressed
      sprite show 1,MM.HRES-1,MM.VRES-50,0 ' put them offscreen
      sprite show 2,MM.HRES-1,MM.VRES-1,0
      d = LoadLevel(level)
      DrawCurrentLevel
    endif
    if k$ = chr$(27) then ? @(0,400) : end
'    if k$ = "s" then save image "FFpic"

    page copy 1 to 0,B ' display the buffer
    pause 15

  loop

  GameFinished

loop

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' Oh drat! We've run out of levels to offer the player.
sub GameFinished

  page write 0
  rbox 300,250,400,100,10,rgb(yellow),rgb(yellow)
  rbox 304,254,392, 92,10,rgb(yellow),rgb(black)
  text 500,290, "CONGRATULATIONS!", "CB" , 3, 1, &hFFB000, -1
  text 500,294, "You have completed all levels.", "CT" , 2, 1, &hFFB000, -1
  text 500,340, "Press the space bar to quit...", "CB" , 1, 1, &hA0A0A0, -1
  ? @(0,350)
  do
  loop until INKEY$ <> ""
  end

end sub

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
sub TryShiftTiles

  sprite show 1,MM.HRES-1,MM.VRES-50,0 ' put open hand offscreen
  if locky = 0 then ' look for button down event
    locky = cy
    lockx = cx
    htile      = GetTile(lockx  ,locky)
    htileleft  = GetTile(lockx-1,locky)
    htileright = GetTile(lockx+1,locky)
  else  ' button already down so look for side shift
    if htile > 0 and htile < 8 then
      if cx < lockx and htileleft = 0 then ' can we shift left?
        sprite show 2,MM.HRES-1,MM.VRES-1,0  ' move closed hand offscreen to restore image
        SetTile(lockx,locky,0)  ' erase tile at old position
        lockx = lockx - 1
        SetTile(lockx,locky,htile) ' move tile to new position
        htileleft  = GetTile(lockx-1,locky)
        htileright = 0   ' leave blank behind us
        ' play scraping tile sound
        play stop : play wav "Slide.wav"
        DrawPlayingArea
        page copy 1 to 0,B ' show new image
'        pause 25
        if DoPhysics() then htile=GetTile(lockx,locky) ' may need to let go of the tile
      endif  
      if cx > lockx and htileright = 0 then ' can we shift right?
        sprite show 2,MM.HRES-1,MM.VRES-1,0  ' move closed hand offscreen to restore image
        SetTile(lockx,locky,0)  ' erase tile at old position
        lockx = lockx + 1
        SetTile(lockx,locky,htile) ' move tile to new position
        htileleft  = 0   ' leave blank behind us
        htileright = GetTile(lockx+1,locky)
        ' play scraping tile sound
        play stop : play wav "Slide.wav"
        DrawPlayingArea
        page copy 1 to 0,B ' show new image
'        pause 25
        if DoPhysics() then htile=GetTile(lockx,locky) ' may need to let go of the tile
      endif
    endif  
  endif
  sprite show 2,hx,locky*30+YOFFSET,0 ' show closed hand locked vertically to tile

end sub

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' Check for and move pieces according to gravity and fusion
' Do gravity (falling down) first, from bottom to top
' Then do fusion.
' Repeat until there are no more changes. (Fusion could open
' new gaps, allowing more tiles to fall.)
function DoPhysics()

  local result,r

  result = 0
  do  ' keep looping until nothing fuses
    lastfall = 0
    do  ' keep looping until nothing falls
      r = DoFalling()
      if r then
        DrawPlayingArea
        page copy 1 to 0,B ' show new image
        pause 100
        result = 1
      else
        ' clink sound only at bottom of falling
        if lastfall then play wav "Clink.wav"
        exit do
      endif
    loop

    if DoFusing() = 0 then exit do
    result = 1
  loop

  DoPhysics = result

end function

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' Perform a single iteration of falling tiles
function DoFalling()

  local integer tc

  changed = 0
  for y = PLAYHEIGHT-2 to 1 step -1
    for x = 2 to PLAYWIDTH-1
      tc = GetTile(x,y)
      if tc > 0 and tc < 8 then ' is this a playing tile?
        if GetTile(x,y+1) = 0 then ' is below blank?
          SetTile(x,y,0)
          SetTile(x,y+1,tc)
          changed = 1
          lastfall = 1
        endif
      endif
    next x
  next y
  DoFalling = changed
end function

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' Compare each tile to its neighbor right and down.
' If they match, mark them for fusion
function DoFusing()

  local integer tile

  'for y = 0 to PLAYHEIGHT : fusem(y)="............" : next y
  for y = 0 to PLAYHEIGHT : fusem(y)=SPACE$(PLAYWIDTH+1) : next y
  boom = 0
  for y = 1 to PLAYHEIGHT-1
    for x = 2 to PLAYWIDTH-1
      tile = GetTile(x,y)
      if tile > 0 and tile < 8 then
        if tile = GetTile(x+1,y) then  ' check tile to the right
          mid$(fusem(y),x,1)) = "*"
          mid$(fusem(y),x+1,1)) = "*"
          boom = 1
        endif
        if tile = GetTile(x,y+1) then  ' check tile below
          mid$(fusem(y),x,1)) = "*"
          mid$(fusem(y+1),x,1)) = "*"
          boom = 1
        endif
      endif
    next x
  next y

  if boom then    ' matching neighbours so make things go boom
    play stop   ' stop possible previous phwoosh or clink
    play wav "Pop.wav"
    for a = 1 to 3  ' animate explosion frames
      for y = 1 to PLAYHEIGHT-1
        for x = 2 to PLAYWIDTH-1
          ' show explosion animation image
          if mid$(fusem(y),x,1) = "*" then
            blit (8+a)*30,30,XOFFSET+(x+7)*30,YOFFSET+y*30,30,30,2
            SetTile(x,y,0)  ' erase the tile
          endif
        next x
      next y
      ' display screen
      page copy 1 to 0,B
      pause 100
    next a
    DrawPlayingArea
    page copy 1 to 0,B
  endif
  DoFusing = boom
end function

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
sub DrawCurrentLevel

  DrawPlayingArea

  ' erase previous level numeral
  DrawTile(17, 30,5*30)   ' metal tile background
  DrawTile(17, 60,5*30)
  DrawTile(17, 90,5*30)
  DrawTile(17,120,5*30)
  ' draw new level numeral
  text 90+XOFFSET, 150+YOFFSET, str$(LEVEL), "CT" , 5, 1, &hFFB000, -1
  text 88+XOFFSET, 152+YOFFSET, str$(LEVEL), "CT" , 5, 1, &hFFB000, -1
  text 92+XOFFSET, 152+YOFFSET, str$(LEVEL), "CT" , 5, 1, &hFFB000, -1
  text 90+XOFFSET, 154+YOFFSET, str$(LEVEL), "CT" , 5, 1, &hFFB000, -1

end sub

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' Draw the current playing area as held in the 'currentlevel' array
' Also updates 'tilecount' with the number of tiles remaining
sub DrawPlayingArea
  tilecount = 0
  for y = 0 to PLAYHEIGHT
    for x = 1 to PLAYWIDTH
      t = GetTile(x,y)
      if t  > 0 and t < 8 then tilecount = tilecount + 1
      DrawTile(t,(x+7)*30,y*30)
    next x
  next y
end sub

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' Return the tile at the given coordinates
' Valid tiles are 0 to 9
' Returns -1 for invalid request
function GetTile(x,y)
  if x > 0 and x <= PLAYWIDTH and y >= 0 and y <= PLAYHEIGHT then
    GetTile = val(mid$(currentlevel(y),x,1))
  else
    GetTile = -1
  endif
end function

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' Set the tile at the given coordinates
sub SetTile(x,y,tile)
  if x > 0 and x <= PLAYWIDTH and y >= 0 and y <= PLAYHEIGHT then
    mid$(currentlevel(y),x,1)) = str$(int(tile))
  endif
end sub

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' fill the screen with bricks - the background image
sub DrawBrickWall
  for y = 0 to PLAYHEIGHT
    for x = 0 to PLAYWIDTH + 7
      DrawTile(8,x*30,y*30)
    next x
  next y
end sub

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' bolt on a sheet of metal for displaying the level
sub DrawMetalSign
  DrawTile(13,  0,3*30)
  DrawTile(14, 30,3*30)
  DrawTile(14, 60,3*30)
  DrawTile(14, 90,3*30)
  DrawTile(14,120,3*30)
  DrawTile(15,150,3*30)

  for i = 4 to 5
    DrawTile(16,  0,i*30)
    DrawTile(17, 30,i*30)
    DrawTile(17, 60,i*30)
    DrawTile(17, 90,i*30)
    DrawTile(17,120,i*30)
    DrawTile(18,150,i*30)
  next i

  DrawTile(19,  0,6*30)
  DrawTile(20, 30,6*30)
  DrawTile(20, 60,6*30)
  DrawTile(20, 90,6*30)
  DrawTile(20,120,6*30)
  DrawTile(21,150,6*30)

  ' add level text
  text 90+XOFFSET, 110+YOFFSET, "LEVEL", "CT" , 5, 1, &hFFB000, -1
  text 88+XOFFSET, 112+YOFFSET, "LEVEL", "CT" , 5, 1, &hFFB000, -1
  text 92+XOFFSET, 112+YOFFSET, "LEVEL", "CT" , 5, 1, &hFFB000, -1
  text 90+XOFFSET, 114+YOFFSET, "LEVEL", "CT" , 5, 1, &hFFB000, -1
end sub

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' draw the requested tile on the buffer at the given coordinates
' Tile #0 is a black box
' each tile is 30x30 pixels
' tiles are stored beside each other on page 2
sub DrawTile(num,x,y)

  if num then
    if num < 13 then
      blit (num-1)*30,0,XOFFSET+x,YOFFSET+y,30,30,2
    else
      blit (num-13)*30,30,XOFFSET+x,YOFFSET+y,30,30,2
    endif
  else
    box XOFFSET+x,YOFFSET+y,30,30,1,0,0
  endif

end sub

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' Load the requested level from the data statements
' restore command only seems to accept literals so a long select case is required
' Return 0 if no more levels, level number otherwise
function LoadLevel(level)

  if level > MAXLEVEL then
    LoadLevel = 0
    exit function
  endif

  select case level
    case 1
      restore Level_1
    case 2
      restore Level_2
    case 3
      restore Level_3
    case 4
      restore Level_4
    case 5
      restore Level_5
    case 6
      restore Level_6
    case 7
      restore Level_7
    case 8
      restore Level_8
    case 9
      restore Level_9
    case 10
      restore Level_10
    case 11
      restore Level_11
    case 12
      restore Level_12
    case 13
      restore Level_13
    case 14
      restore Level_14
    case 15
      restore Level_15
    case 16
      restore Level_16
    case 17
      restore Level_17
    case 18
      restore Level_18
    case 19
      restore Level_19
    case 20
      restore Level_20
    case 21
      restore Level_21
    case 22
      restore Level_22
    case 23
      restore Level_23
    case 24
      restore Level_24
    case 25
      restore Level_25
    case 26
      restore Level_26
    case 27
      restore Level_27
    case 28
      restore Level_28
    case 29
      restore Level_29
    case 30
      restore Level_30
    case 31
      restore Level_31
    case 32
      restore Level_32
    case 33
      restore Level_33
    case 34
      restore Level_34
    case 35
      restore Level_35
    case 36
      restore Level_36
    case 37
      restore Level_37
    case 38
      restore Level_38
    case 39
      restore Level_39
    case 40
      restore Level_40
    case 41
      restore Level_41
    case 42
      restore Level_42
    case 43
      restore Level_43
    case 44
      restore Level_44
    case 45
      restore Level_45
    case 46
      restore Level_46
    case 47
      restore Level_47
    case 48
      restore Level_48
    case 49
      restore Level_49
    case 50
      restore Level_50
    case 51
      restore Level_51
    case 52
      restore Level_52
    case 53
      restore Level_53
    case 54
      restore Level_54
    case 55
      restore Level_55
    case 56
      restore Level_56
    case 57
      restore Level_57
    case 58
      restore Level_58
    case 59
      restore Level_59
    case 60
      restore Level_60
  end select

  for i = 0 to 12
    read currentlevel(i)
  next i

  LoadLevel = level

end function

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' Read the title data and paint it on the screen
' Attempt to mimic spray painting
sub PaintTitle(x,y,scale,colr)
  restore ff2string  ' move read pointer to data
  do
    read x1,y1
'? x1,y1
    do
      read x2,y2
      if x2 = 0 then exit do  ' stroke done
      PaintLine(x+x1*scale,y+y1*scale,x+x2*scale,y+y2*scale,colr)
      x1 = x2
      y1 = y2
    loop
    if y2 = 0 then exit do  ' all done
    pause y2
  loop
end sub

' Paint a line from x0,y0 to x1,y1
' Use Bresenham's algorithm and draw small circles
' for each position along the line
' Desired speed is slow, as if spray painting.
sub PaintLine(x0,y0,x1,y1,c)

  local integer dx, dy, stepx, stepy, frac

  x0 = int(x0) : y0 = int(y0)  
  x1 = int(x1) : y1 = int(y1)  
  dy = y1 - y0 : dx = x1 - x0 
  
  stepy = 1
  if dy < 0 then dy = -dy : stepy = -1

  stepx = 1
  if dx < 0 then dx = -dx : stepx = -1
  
  dy = dy * 2
  dx = dx * 2

  ' draw starting point
  circle x0, y0, SPRAYSIZE, SPRAYSIZE, 1, c 
  
  if(dx > dy) then ' shallow line = iterate over x
  frac = dy - dx / 2
  do while x0 <> x1
      if frac >= 0 then y0 = y0 + stepy : frac = frac - dx
      x0 = x0 + stepx
      frac = frac + dy
      circle x0, y0, SPRAYSIZE, SPRAYSIZE, 1, c
    pause STROKESPEED
  loop
  else  ' steep line = iterate over y
  frac = dx - dy / 2
  do while y0 <> y1
      if frac >= 0 then x0 = x0 + stepx : frac = frac - dy
      y0 = y0 + stepy
      frac = frac + dx
      circle x0, y0, SPRAYSIZE, SPRAYSIZE, 1, c
    pause STROKESPEED
  loop
  endif

end sub

' Stroke encoded lettering.
' Form characters by drawing lines point to point.
' End of stroke indicated by (0,n)
'   where n is delay (ms) before starting next stroke
' End of image indicated by (0,0)

ff2String:
' F  3 strokes
data 2.8750,2.0900
data 1.5000,6.0900
data 0,100

data 2.4899,2.1478
data 6.1250,1.6025
data 0,100

data 1.9600,4.1200
data 3.7500,3.8400
data 0,50
' A  3 strokes
data 5.9565,2.4139
data 3.3315,6.1639
data 0,50

data 5.9565,2.4139
data 6.3315,6.1639
data 0,50

data 4.1190,5.0389
data 6.8315,4.2889
data 0,50
' L  1 stroke
data 8.6200,2.1250
data 7.2500,5.8750
data 9.2500,5.3750
data 0,25
' F  3 strokes
data 11.1250,2.3750
data 9.8789,6.0000
data 0,100

data 10.5299,2.4643
data 13.4150,2.0315
data 0,100

data 10.4375,4.3750
data 12.0000,4.1250
data 0,50
' U
'ff2string:
data 14.1282,2.1600
data 13.2043,4.9230
data 13.1778,5.2580
data 13.2369,5.5379
data 13.3659,5.7640
data 13.6190,5.9120
data 13.9912,6.0116
data 14.3846,5.9359
data 14.8206,5.7437
data 15.2034,5.4195
data 15.4480,5.0750
data 15.5490,4.8317
data 16.4400,2.1600
data 0,1
' S
data 18.9423,3.1000
data 19.0823,2.8600
data 19.1023,2.6800
data 19.0623,2.4800
data 18.9423,2.2800
data 18.8100,2.1750
data 18.5850,2.1100
data 18.2623,2.0800
data 18.0023,2.1000
data 17.7223,2.2000
data 17.5023,2.3200
data 17.3023,2.5600
data 17.1340,2.8660
data 17.1023,3.1800
data 17.1640,3.4480
data 17.3623,3.7400
data 17.6150,3.9300
data 17.9823,4.1000
data 18.3623,4.2400
data 18.6480,4.3340
data 18.8623,4.5000
data 19.0023,4.7800
data 19.0023,5.0800
data 18.9423,5.3000
data 18.7823,5.5200
data 18.5680,5.7920
data 18.2900,5.9760
data 17.9460,6.1120
data 17.6350,6.1950
data 17.2300,6.1750
data 16.8700,5.9250
data 16.5600,5.6800
data 16.4600,5.1400
data 0,1
' 2
data 20.7080,2.2195
data 21.0979,1.9829
data 21.5382,1.8327
data 21.9692,1.7620
data 22.2894,1.7791
data 22.6645,1.8428
data 22.9464,2.0165
data 23.1372,2.2803
data 23.2462,2.5547
data 23.2643,2.9192
data 23.1936,3.3540
data 23.0749,3.6825
data 22.8056,4.0941
data 22.5127,4.3621
data 22.0272,4.7285
data 18.5500,7.4000
data 23.3515,6.6744
data 0,0     ' end of character data

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
'
' HEY! DON'T LOOK HERE! THAT'S CHEATING!
'
Level_1:
data "8888888888889998"
data "8899998888996009"
data "8910019889599909"
data "8899998889600009"
data "8888888889599998"
data "8899998888988888"
data "8920029888888888"
data "8990998888999888"
data "8889888889003988"
data "8899999888909888"
data "8940404989303988"
data "8899909888939888"
data "8888898888898888"

Level_2:
data "8888888888888888"
data "8888888888888888"
data "8888999999988888"
data "8889900000988888"
data "8889000004988888"
data "8889000057988888"
data "8889000162988888"
data "8889005623988888"
data "8889041739988888"
data "8889999999888888"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"

Level_3:
data "8888888888888888"
data "8888999999888888"
data "8888900239888888"
data "8888900679888888"
data "8888990519888888"
data "8888890499888888"
data "8888890998888888"
data "8888994099888888"
data "8888956009888888"
data "8888972009888888"
data "8888913009888888"
data "8888999999888888"
data "8888888888888888"

Level_4:
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"
data "8899998999998888"
data "8895099906098888"
data "8891509014698888"
data "8899140149998888"
data "8889954599888888"
data "8888999998888888"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"

Level_5:
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"
data "8889999999999888"
data "8889060400009888"
data "8889010600009888"
data "8889050502079888"
data "8889040107029888"
data "8889999999999888"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"

Level_6:
data "8888888888888888"
data "8888888899998888"
data "8888888890498888"
data "8888888990598888"
data "8888889901998888"
data "8888889009988888"
data "8888899009888888"
data "8888990099888888"
data "8888945998888888"
data "8888910988888888"
data "8888999988888888"
data "8888888888888888"
data "8888888888888888"

Level_7:
data "8888888888888888"
data "8888888888888888"
data "8888999999998888"
data "8888946000098888"
data "8888999050098888"
data "8888900090098888"
data "8888900090498888"
data "8888961009998888"
data "8888916500698888"
data "8888999999998888"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"

Level_8:
data "8888889998888888"
data "8888890009888888"
data "8888910004988888"
data "8888990059988888"
data "8888999099988888"
data "8888990009988888"
data "8888900000988888"
data "8888991019988888"
data "8888905050988888"
data "8888894049888888"
data "8888889498888888"
data "8888888988888888"
data "8888888888888888"

Level_9:
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"
data "8889999999999888"
data "8889400505009888"
data "8889600601009888"
data "8889454105009888"
data "8889999999999888"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"

Level_10:
data "8888888888888888"
data "8888888889999888"
data "8888888989049888"
data "8888889499059888"
data "8888889500499888"
data "8888999990988888"
data "8889909999888888"
data "8889404988888888"
data "8889545988888888"
data "8889959988888888"
data "8888999888888888"
data "8888888888888888"
data "8888888888888888"

Level_11:
data "8889999999999888"
data "8889000000009888"
data "8889002350009888"
data "8889006940009888"
data "8889009990009888"
data "8889307005659888"
data "8889296001969888"
data "8889999009999888"
data "8889000454009888"
data "8889000791009888"
data "8889000999009888"
data "8889999999999888"
data "8888888888888888"

Level_12:
data "8999999999999998"
data "9000000000000009"
data "9000000000005109"
data "9009999969909909"
data "9090000936909009"
data "9090000943909009"
data "9090000954909009"
data "9090000925909009"
data "9009990949909909"
data "9000000020000009"
data "9000000450100109"
data "8999999999999998"
data "8888888888888888"

Level_13:
data "8888888888888888"
data "8888888888888888"
data "8999999999999998"
data "8900000000000198"
data "8900400200000298"
data "8900560400500198"
data "8999999909999998"
data "8900000000000098"
data "8900000000000098"
data "8900000000000098"
data "8910000900906198"
data "8999999999999998"
data "8888888888888888"

Level_14:
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"
data "8888899999998888"
data "8888900003009888"
data "8889000099998888"
data "8889000000219888"
data "8889000999998888"
data "8888902019888888"
data "8888923198888888"
data "8888899988888888"
data "8888888888888888"
data "8888888888888888"

Level_15:
data "8888888888888888"
data "8888899998888888"
data "8888900009998888"
data "8888900000009888"
data "8888900000609888"
data "8889000000509888"
data "8889500000629888"
data "8889600999999888"
data "8888900000009888"
data "8888900000009888"
data "8888902000009888"
data "8888899999998888"
data "8888888888888888"

Level_16:
data "8888999999998888"
data "8889999999999888"
data "8899900000099988"
data "8999000000209998"
data "8890094005900988"
data "8890909009090988"
data "8890090000900988"
data "8890000010000988"
data "8890000020000988"
data "8890090010900988"
data "8889009999009888"
data "8888900450098888"
data "8888899999988888"

Level_17:
data "8888888899988888"
data "8888888900988888"
data "8888889001988888"
data "8888990009988888"
data "8889100000598888"
data "8889400000998888"
data "8889300000029888"
data "8889200000099888"
data "8888949002009888"
data "8888939001009888"
data "8888929009529888"
data "8888899999998888"
data "8888888888888888"

Level_18:
data "8888999999988888"
data "8889010001098888"
data "8999999099999988"
data "9542130002134598"
data "8999990009999988"
data "8888890009888888"
data "8888890009888888"
data "8888890009888888"
data "8888890009888888"
data "8888890009888888"
data "8888894549888888"
data "8888889998888888"
data "8888888888888888"

Level_19:
data "8888888888888888"
data "8999999999999998"
data "8900004000000098"
data "8900002000400098"
data "8900001000100098"
data "8900099999990098"
data "8900098888890098"
data "8900098888890098"
data "8900098888890098"
data "8900098888890098"
data "8910098888892098"
data "8999998888899998"
data "8888888888888888"

Level_20:
data "8888888888888888"
data "8888888888888888"
data "8888999999988888"
data "8889600005098888"
data "8895200023098888"
data "8889900099988888"
data "8890100060098888"
data "8893200013098888"
data "8889900099988888"
data "8888900098888888"
data "8888900098888888"
data "8888919098888888"
data "8888898988888888"

Level_21:
data "9999999999999999"
data "9000023992300009"
data "9000099999900009"
data "9000000000000009"
data "9000000000000009"
data "9000000000000009"
data "9000002323000009"
data "9000619999160009"
data "9006198888916009"
data "9001988888891009"
data "9069888888889609"
data "9098888888888909"
data "9988888888888899"

Level_22:
data "8888888888888888"
data "8899999999999988"
data "8894231004052988"
data "9999999009999999"
data "9000009009000009"
data "9000600000000009"
data "9000109009000069"
data "9000509999000039"
data "9999999889999999"
data "8888888888888888"
data "8889888888889888"
data "8889999999999888"
data "8888888888888888"

Level_23:
data "8888888888888999"
data "8888888888899619"
data "8888888888940298"
data "8888888899021988"
data "8888888900319888"
data "8888889043998888"
data "8888890029888888"
data "8889945398888888"
data "8890021988888888"
data "8900399888888888"
data "9045988888888888"
data "9619888888888888"
data "9998888888888888"

Level_24:
data "8888999999998888"
data "8889035050009888"
data "8889024135009888"
data "8889041613009888"
data "8889012361309888"
data "8889099999909888"
data "8889098888909888"
data "8889098888909888"
data "8889098888909888"
data "8889098888909888"
data "8890098888900988"
data "8889098888909888"
data "8888988888898888"

Level_25:
data "8888888888888888"
data "9999999999999999"
data "9000610300305009"
data "9909999999999999"
data "9000000040000098"
data "9999999999999098"
data "9000004000500098"
data "9909999999999998"
data "9000000100300098"
data "9999999999999098"
data "9600000000000098"
data "9969999999999998"
data "8999888888888888"

Level_26:
data "8888888888888888"
data "8888888888888888"
data "8988888888888898"
data "8999999999999998"
data "8960000000099998"
data "8950000000000198"
data "8940000000000298"
data "8930000000001398"
data "8950000000009998"
data "8995404612029998"
data "8999999999999998"
data "8888888888888888"
data "8888888888888888"

Level_27:
data "8999999999999988"
data "8900610003500988"
data "8999999099999988"
data "8890514003409888"
data "8899999099999888"
data "8889610003598888"
data "8889999099998888"
data "8888920002988888"
data "8888999099988888"
data "8888890009888888"
data "8888899099888888"
data "8888889098888888"
data "8888889998888888"

Level_28:
data "8999999999988888"
data "9000000000098888"
data "9010205000609888"
data "9090909090900988"
data "9020205030201098"
data "9090909090909098"
data "9040404030602098"
data "9090909090909098"
data "9010105010306098"
data "9090909090909098"
data "9000000000000098"
data "9090909090909098"
data "8999999999999988"

Level_29:
data "8888889998888888"
data "8888890209888888"
data "8888890909888888"
data "8888902010988888"
data "8888909090988888"
data "8889030203098888"
data "8889090909098888"
data "8890105050409888"
data "8890909090909888"
data "8900000100050988"
data "8909490939090988"
data "8999999999999988"
data "8888888888888888"

Level_30:
data "8888888888888888"
data "8888888888888888"
data "8889999999999988"
data "8889005042600988"
data "8889009025900988"
data "8889000959000988"
data "8889000496300988"
data "8889003939200988"
data "8889009020900988"
data "8889000610109988"
data "8889999999999988"
data "8888888888888888"
data "8888888888888888"

Level_31:
data "8899999999999888"
data "8904010000040988"
data "8919090909090988"
data "8890205050509888"
data "8892909090909888"
data "8889030300098888"
data "8889090909098888"
data "8890606060009888"
data "8890909090909888"
data "8900000003000988"
data "8909090909090988"
data "8999999999999988"
data "8888888888888888"

Level_32:
data "9998888888888999"
data "9509988888899619"
data "8900098888945298"
data "8894009999021988"
data "8889000000319888"
data "8888990000998888"
data "8888890500988888"
data "8889940300099888"
data "8890021990000988"
data "8900399889900098"
data "9045988888890009"
data "9619888888889009"
data "9998888888888999"

Level_33:
data "8888888888888888"
data "8888999999999898"
data "8889152525100929"
data "8999999999900939"
data "9000000012410929"
data "9009099999999939"
data "9098988888888929"
data "9098888888888939"
data "9098888888888929"
data "9099999999999939"
data "9012341526315429"
data "9041234152631549"
data "8999999999999998"

Level_34:
data "8888899999988888"
data "8888999903998888"
data "8889999009999888"
data "8899999399999988"
data "8999009990099998"
data "9990300300039999"
data "9900500500599999"
data "9960600600699999"
data "9910100100199999"
data "8990400400409998"
data "8899204240299988"
data "8889902920999888"
data "8888999999998888"

Level_35:
data "8888888888888888"
data "8899999999999988"
data "8900000000000098"
data "8920200000000098"
data "8950101006060698"
data "8910999009990598"
data "8890009009000988"
data "8890009009000988"
data "8890009009000988"
data "8891009009005988"
data "8889959109099888"
data "8888899999988888"
data "8888888888888888"

Level_36:
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"
data "8999999999999998"
data "8900000320005298"
data "8912340992021698"
data "8951234991632198"
data "8945123996261698"
data "8934512992316598"
data "8923451993263198"
data "8999999999999998"
data "8888888888888888"
data "8888888888888888"

Level_37:
data "8899999999999888"
data "8890000046569888"
data "8890000031459888"
data "8890000012329888"
data "8890000099999888"
data "8890000098888888"
data "8890000098888888"
data "8890000098888888"
data "8890000098888888"
data "8899900099999888"
data "8888999654329888"
data "8888889999999888"
data "8888888888888888"

Level_38:
data "8888888888888888"
data "8888999999998888"
data "8889005000409888"
data "8889042004209888"
data "8889024526309888"
data "8889099999909888"
data "8889000960009888"
data "8889000690009888"
data "8889000960009888"
data "8889000690009888"
data "8889003960009888"
data "8888999999998888"
data "8888888888888888"

Level_39:
data "8888888888888888"
data "8888899999988888"
data "8888900000098888"
data "8889000000009888"
data "8895600000006988"
data "8934500000005498"
data "8892300000063988"
data "8889120000029888"
data "8888910000198888"
data "8888890000988888"
data "8888889009888888"
data "8888888998888888"
data "8888888888888888"

Level_40:
data "8888999999998888"
data "8889035050009888"
data "8889024135009888"
data "8889041613009888"
data "8889012361309888"
data "8889099999909888"
data "8889098888909888"
data "8889098888909888"
data "8889098888909888"
data "8889098888909888"
data "8890098888900988"
data "8889098888909888"
data "8888988888898888"

Level_41:
data "8888888888888888"
data "8888888888999988"
data "8888888899052098"
data "8889999943615198"
data "8890020459999988"
data "8890190999888888"
data "8890390999888888"
data "8889990006988888"
data "8888899099888888"
data "8888889009888888"
data "8888889098888888"
data "8888888988888888"
data "8888888888888888"

Level_42:
data "8888999999999888"
data "8889000303030988"
data "8890000999999998"
data "8900000006014209"
data "8900000999999999"
data "8900000400500509"
data "8900000999999999"
data "8900000010000069"
data "8900090999999999"
data "8929090009888888"
data "8919190009888888"
data "8999999999888888"
data "8888888888888888"

Level_43:
data "8889999999999988"
data "8893540456000698"
data "8889999999120998"
data "8888888888990988"
data "8888888999900988"
data "8888889300000988"
data "8888888999990988"
data "8888888888890988"
data "8888888888890988"
data "8888888888891988"
data "8888888888892988"
data "8888888888889888"
data "8888888888888888"

Level_44:
data "8888888888888888"
data "8999999999999998"
data "9500000000000129"
data "9990000000000999"
data "9430000006000319"
data "9990000001000999"
data "9040000003000039"
data "9990000002000099"
data "9450009001090019"
data "9990009999990099"
data "9000003000600009"
data "9990909090909099"
data "8889898989898988"

Level_45:
data "8888888888888888"
data "8888888888888888"
data "8999999999999988"
data "8900000000000988"
data "8900000400000988"
data "8900003630000988"
data "8900052312000988"
data "8900536165200988"
data "8903243613560988"
data "8912436165356988"
data "8999999999999988"
data "8888888888888888"
data "8888888888888888"

Level_46:
data "8888899999998888"
data "8888934210609888"
data "8888899990998888"
data "8888906000659888"
data "8888899099998888"
data "8888890000009888"
data "8888899990998888"
data "8888950000059888"
data "8888899099998888"
data "8888889000309888"
data "8888888993429888"
data "8888888894219888"
data "8888888889998888"

Level_47:
data "8889999999998888"
data "8889101010098888"
data "8889999999098888"
data "8889202024098888"
data "8889999999098888"
data "8889303430098888"
data "8889999999098888"
data "8889004040098888"
data "8889999999098888"
data "8889005050098888"
data "8889999999098888"
data "8889006060098888"
data "8889999999998888"

Level_48:
data "8888888888888888"
data "8888888888888888"
data "8899999999999988"
data "8890000010243988"
data "8890030020451988"
data "8891043090536988"
data "8899999090999988"
data "8889000090209888"
data "8889000490609888"
data "8889999999999888"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"

Level_49:
data "8888888888888888"
data "8889999999988888"
data "8890000000098888"
data "8892140460009888"
data "8889999999900988"
data "8890000000100988"
data "8890000000900988"
data "8892000039000988"
data "8893000390000988"
data "8895005900900988"
data "8891059404916988"
data "8889999999999888"
data "8888888888888888"

Level_50:
data "8889999999999888"
data "8891032100000988"
data "8896321505000988"
data "8889999909061988"
data "8888888909999888"
data "8888888909888888"
data "8888888909888888"
data "8888888909888888"
data "8888888909888888"
data "8888889000988888"
data "8888889000988888"
data "8888888999888888"
data "8888888888888888"

Level_51:
data "8888888889999988"
data "8888888890043498"
data "8888888900099998"
data "8888889000050198"
data "8888890000099998"
data "8888900000053298"
data "8889000000099998"
data "8890009909020498"
data "8900009009099998"
data "9000029009000098"
data "9100019939020498"
data "8999999999999988"
data "8888888888888888"

Level_52:
data "8888888888888888"
data "8888888888888888"
data "8889999999999988"
data "8889000010050988"
data "8889000090040988"
data "8889005293210988"
data "8889099999990988"
data "8889000690000988"
data "8889002490000988"
data "8889006303100988"
data "8889999999999988"
data "8888888888888888"
data "8888888888888888"

Level_53:
data "8888888888888888"
data "8888999999999988"
data "8888920123456988"
data "8888930999999988"
data "8888940498888888"
data "8888910198888888"
data "8888960598888888"
data "8888950398888888"
data "8888990298888888"
data "8888990698888888"
data "8888990998888888"
data "8888999998888888"
data "8888888888888888"

Level_54:
data "8899999999999988"
data "8960504503042098"
data "8899999999999009"
data "8905306202420309"
data "9009999999999998"
data "9000650000304039"
data "8999999990909998"
data "8888888893909888"
data "8888888889909888"
data "8888888888909888"
data "8889999999003988"
data "8890000540069988"
data "8889999999998888"

Level_55:
data "8888888888888888"
data "8899999999999988"
data "8900020006305098"
data "9069093035929039"
data "9029991451999519"
data "9052032523106369"
data "9063025414304149"
data "9121063143403419"
data "9999999999999999"
data "8898898888988988"
data "8898898888988988"
data "8988889889888898"
data "8888888888888888"

Level_56:
data "8888888888888888"
data "8899888888899888"
data "8940988888905988"
data "8932988888914988"
data "8894298889069888"
data "8893698889059888"
data "8889209890098888"
data "8889609890598888"
data "8888920900988888"
data "8888930005988888"
data "8888890009888888"
data "8888892159888888"
data "8888889998888888"

Level_57:
data "8889999999998888"
data "8896060000009888"
data "8912320000002988"
data "8893230400003988"
data "8889990200001988"
data "8890000400099988"
data "8895000900000988"
data "8889400900940988"
data "8888900900999988"
data "8888906900000988"
data "8888905900000988"
data "8888999999999888"
data "8888888888888888"

Level_58:
data "8888888888888888"
data "8888888888888888"
data "8999999999988888"
data "8923456000988888"
data "8999999000988888"
data "9999999000999999"
data "9023456001010109"
data "9019191909090909"
data "9999999999999999"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"
data "8888888888888888"

Level_59:
data "8888899999999998"
data "8888930434040409"
data "8888913212021239"
data "8888965121012129"
data "8889999999099959"
data "8889000000098898"
data "8889699099098888"
data "8888989099098888"
data "8888889099098888"
data "8888889099098888"
data "8888889009009888"
data "8888889009000988"
data "8888888998999888"

Level_60:
data "8889999999998888"
data "8894523000009888"
data "8895432001019888"
data "8899999009999988"
data "8890046002600098"
data "8890025005200198"
data "8890099009900988"
data "8890099009900988"
data "8890099009900988"
data "8890099009900988"
data "8890099009900988"
data "8889988998899888"
data "8888888888888888"


